#include<stdio.h>
#include<math.h>


int main(){

  double x;

  /* exp(x)のテーラー展開の結果を返す関数のプロトタイプ宣言 */
  double exptaylor(double, int);

  /* xは-10から0.5きざみで10まで変える */
  for(x=-10.0;x<10.01;x+=0.5){

    /* 結果の出力 */
    printf("%20.10f %20.10f %20.10f %20.10f %20.10f %20.10f\n", x, exp(x), exptaylor(x,10), exptaylor(x,20),exptaylor(x,30), exptaylor(x,40));

  }

  return 0;
  
}

/* exp(x)のテーラー展開のn次までを計算する関数 */
double exptaylor(double x, int n){

  double taylor = 0.0; // 関数として返す値を代入する変数。初期値0をセット
  double factorial(int); // 階乗の関数のプロトタイプ宣言
  int k;

  /* k次の展開項を足し上げる */
  for(k=0; k<n+1; k++){

    taylor += pow(x,k)/factorial(k); // k!は別の関数を呼び出して計算

  }
  
  return(taylor); // taylorの値を返して関数を終了
  
}

/* 階乗の計算 */
double factorial(int n){
    
  int k;
  double fact;

  fact = 0.0;
  if( n < 0) return (fact);

  fact = 1.0;
  if(n==0) return(fact);

  for(k=1;k<n+1;k++){

    fact *= (double) k;

  }
    
  return(fact);

}
